
import React from 'react';
import { StyleSheet, Text, View, Image, Button, Alert, ScrollView } from 'react-native';

export default class App extends React.Component {
  
  constructor(props) {

    super(props);
  
    this.state = {
      cont: 0,
      nrs: ['-', '-', '-', '-', '-', '-'],
      col: ['-', '-', '-', '-', '-', '-'],
      sor: ['-', '-', '-', '-', '-', '-'],
    };

  }

  setCorBotao(valor) {

    for (let i=0; i < this.state.col.length; i++) {
      if(this.state.col[i] == valor) {
        return '#B9B6B6';
      }
    }    

    return '#208036'; 
  }

  sortear() {
  
    // Verifica se o jogador já selecionou todos os 6 números
    if(this.state.cont == 6) {

      let sorteio = [0, 0, 0, 0, 0, 0];
      let nr_acertos = 0;

      for(let a=0; a < this.state.sor.length; a++) {
        sorteio[a] = Math.floor(Math.random() * 61) + 1;

        // Verifica o número de acertos
        for(let c=0; c < 6; c++) {
          if(sorteio[a] == this.state.nrs[c]) 
            nr_acertos++;
        } 
      }

      sorteio.sort(function(a, b) { return a - b });

      this.setState({
        sor: sorteio,
      });

      // Apresenta Resultado
      if(nr_acertos == 0) {
        Alert.alert(
          'RESULTADO SORTEIO', 
          'Não foi dessa vez, você não acertou sequer um número!',
          [
            {text: 'OK', onPress: () => { this.reiniciarDados() }},
          ],
        );  
      }
      else if(nr_acertos < 4) {
        Alert.alert(
          'RESULTADO SORTEIO', 
          'Não foi dessa vez, você acertou apenas [' + nr_acertos + '] número(s)!',
          [
            {text: 'OK', onPress: () => { this.reiniciarDados() }},
          ],
        );  
      }
      else if (nr_acertos == 4) {
        Alert.alert(
          'RESULTADO SORTEIO', 
          'Parabéns, você fez uma QUADRA!',
          [
            {text: 'OK', onPress: () => { this.reiniciarDados() }},
          ],
        );  
      }
      else if (nr_acertos == 5) {
        Alert.alert(
          'RESULTADO SORTEIO', 
          'Parabéns, você fez uma QUINA!',
          [
            {text: 'OK', onPress: () => { this.reiniciarDados() }},
          ],
        );   
      }
      else {
        Alert.alert(
          'RESULTADO SORTEIO', 
          'Parabéns, você é o mais novo MILIONÁRIO DA MEGA SENA!',
          [
            {text: 'OK', onPress: () => { this.reiniciarDados() }},
          ],
        );
      }
    }
    // Ainfa não selecionou 6 números
    else {
      Alert.alert('NÃO REALIZADO', 'Por favor, selecione 6 números antes de efetuar o sorteio!');      
    }
  }

  reiniciarDados() {

    // Reinicia os valores Selecionados e Sorteados
    let padrao_nrs = ['-', '-', '-', '-', '-', '-'];
    let padrao_col = ['-', '-', '-', '-', '-', '-'];
    let padrao_sor = ['-', '-', '-', '-', '-', '-'];

    this.setState({
      nrs: padrao_nrs,
      cont: 0,
      col: padrao_col,
      sor: padrao_sor,
    });
  }

  selecionar(valor) {

    // Efetua a seleção
    for (let a=0; a < this.state.nrs.length; a++) {

      if(this.state.nrs[a] == '-') {

        let copia_nrs = this.state.nrs;
        let copia_col = this.state.col;
        copia_nrs[a] = valor;
        copia_col[a] = valor;

        this.setState({
          nrs: copia_nrs,
          cont: this.state.cont+1,
          col: copia_col,
        });

        return;   
      }
    }
  }

  render() {
    return (
      <ScrollView style={styles.main}>
        <View style={styles.logo}> 
          <Image
            source={ require('./img/logo_mega.png') }
            style={{flex: 1, resizeMode: "stretch"}}
          />
        </View>
        <View style={styles.painel}> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="01" color={ this.setCorBotao(1) } onPress={ () => this.selecionar(1) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="02" color={ this.setCorBotao(2) } onPress={ () => this.selecionar(2) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="03" color={ this.setCorBotao(3) } onPress={ () => this.selecionar(3) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="04" color={ this.setCorBotao(4) } onPress={ () => this.selecionar(4) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="05" color={ this.setCorBotao(5) } onPress={ () => this.selecionar(5) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="06" color={ this.setCorBotao(6) } onPress={ () => this.selecionar(6) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="07" color={ this.setCorBotao(7) } onPress={ () => this.selecionar(7) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="08" color={ this.setCorBotao(8) } onPress={ () => this.selecionar(8) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="09" color={ this.setCorBotao(9) } onPress={ () => this.selecionar(9) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="10" color={ this.setCorBotao(10) } onPress={ () => this.selecionar(10) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="11" color={ this.setCorBotao(11) } onPress={ () => this.selecionar(11) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="12" color={ this.setCorBotao(12) } onPress={ () => this.selecionar(12) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="13" color={ this.setCorBotao(13) } onPress={ () => this.selecionar(13) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="14" color={ this.setCorBotao(14) } onPress={ () => this.selecionar(14) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="15" color={ this.setCorBotao(15) } onPress={ () => this.selecionar(15) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="16" color={ this.setCorBotao(16) } onPress={ () => this.selecionar(16) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="17" color={ this.setCorBotao(17) } onPress={ () => this.selecionar(17) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="18" color={ this.setCorBotao(18) } onPress={ () => this.selecionar(18) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="19" color={ this.setCorBotao(19) } onPress={ () => this.selecionar(19) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="20" color={ this.setCorBotao(20) } onPress={ () => this.selecionar(20) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="21" color={ this.setCorBotao(21) } onPress={ () => this.selecionar(21) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="22" color={ this.setCorBotao(22) } onPress={ () => this.selecionar(22) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="23" color={ this.setCorBotao(23) } onPress={ () => this.selecionar(23) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="24" color={ this.setCorBotao(24) } onPress={ () => this.selecionar(24) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="25" color={ this.setCorBotao(25) } onPress={ () => this.selecionar(25) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="26" color={ this.setCorBotao(26) } onPress={ () => this.selecionar(26) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="27" color={ this.setCorBotao(27) } onPress={ () => this.selecionar(27) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="28" color={ this.setCorBotao(28) } onPress={ () => this.selecionar(28) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="29" color={ this.setCorBotao(29) } onPress={ () => this.selecionar(29) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="30" color={ this.setCorBotao(30) } onPress={ () => this.selecionar(30) }/>
            </View> 
          </View>
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="31" color={ this.setCorBotao(31) } onPress={ () => this.selecionar(31) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="32" color={ this.setCorBotao(32) } onPress={ () => this.selecionar(32) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="33" color={ this.setCorBotao(33) } onPress={ () => this.selecionar(33) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="34" color={ this.setCorBotao(34) } onPress={ () => this.selecionar(34) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="35" color={ this.setCorBotao(35) } onPress={ () => this.selecionar(35) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="36" color={ this.setCorBotao(36) } onPress={ () => this.selecionar(36) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="37" color={ this.setCorBotao(37) } onPress={ () => this.selecionar(37) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="38" color={ this.setCorBotao(38) } onPress={ () => this.selecionar(38) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="39" color={ this.setCorBotao(39) } onPress={ () => this.selecionar(39) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="40" color={ this.setCorBotao(40) } onPress={ () => this.selecionar(40) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="41" color={ this.setCorBotao(41) } onPress={ () => this.selecionar(41) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="42" color={ this.setCorBotao(42) } onPress={ () => this.selecionar(42) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="43" color={ this.setCorBotao(43) } onPress={ () => this.selecionar(43) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="44" color={ this.setCorBotao(44) } onPress={ () => this.selecionar(44) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="45" color={ this.setCorBotao(45) } onPress={ () => this.selecionar(45) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="46" color={ this.setCorBotao(46) } onPress={ () => this.selecionar(46) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="47" color={ this.setCorBotao(47) } onPress={ () => this.selecionar(47) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="48" color={ this.setCorBotao(48) } onPress={ () => this.selecionar(48) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="49" color={ this.setCorBotao(49) } onPress={ () => this.selecionar(49) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="50" color={ this.setCorBotao(50) } onPress={ () => this.selecionar(50) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="51" color={ this.setCorBotao(51) } onPress={ () => this.selecionar(51) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="52" color={ this.setCorBotao(52) } onPress={ () => this.selecionar(52) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="53" color={ this.setCorBotao(53) } onPress={ () => this.selecionar(53) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="54" color={ this.setCorBotao(54) } onPress={ () => this.selecionar(54) }/>
            </View> 
          </View> 
          <View style={styles.linha}> 
            <View style={styles.botao}>
              <Button title="55" color={ this.setCorBotao(55) } onPress={ () => this.selecionar(55) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="56" color={ this.setCorBotao(56) } onPress={ () => this.selecionar(56) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="57" color={ this.setCorBotao(57) } onPress={ () => this.selecionar(57) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="58" color={ this.setCorBotao(58) } onPress={ () => this.selecionar(58) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="59" color={ this.setCorBotao(59) } onPress={ () => this.selecionar(59) }/>
            </View> 
            <View style={styles.botao}>
              <Button title="60" color={ this.setCorBotao(60) } onPress={ () => this.selecionar(60) }/>
            </View> 
          </View> 
        </View>
        <View style={styles.painel}>
          <View style={styles.linha}>  
            <View style={styles.circulo}>
              <Text style={styles.texto}>{ this.state.nrs[0] }</Text>  
            </View>
            <View style={styles.circulo}>  
              <Text style={styles.texto}>{ this.state.nrs[1] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto}>{ this.state.nrs[2] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto}>{ this.state.nrs[3] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto}>{ this.state.nrs[4] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto}>{ this.state.nrs[5] }</Text>  
            </View>
          </View>
        </View>
        <View style={styles.sortear}>
          <Button title="Sortear" color='#208036' onPress={ () => this.sortear() }/>
        </View>
        <View style={styles.painel}>
          <View style={styles.linha}>  
            <View style={styles.circulo}>
              <Text style={styles.texto2}>{ this.state.sor[0] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto2}>{ this.state.sor[1] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto2}>{ this.state.sor[2] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto2}>{ this.state.sor[3] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto2}>{ this.state.sor[4] }</Text>  
            </View>
            <View style={styles.circulo}>
              <Text style={styles.texto2}>{ this.state.sor[5] }</Text>  
            </View>
          </View>  
        </View>
      </ScrollView>      
    );
  }
}

const styles = StyleSheet.create({

  main: {
    backgroundColor: '#FFF',
    marginTop: 24,
  },
  logo: {
    flex: 1,
    flexDirection: 'row',
    borderColor: '#208036',
    margin: 2,
    padding: 1,
    borderWidth: 3,
  },
  painel: {
    borderColor: '#208036',
    margin: 2,
    padding: 5,
    borderWidth: 3,
  },
  linha: {
    flexDirection: 'row',
  },
  botao: {
    flex: 1,
    margin: 2,
  },
  circulo: {
    flex: 1,
    margin: 2,
    backgroundColor: '#C89827',
    alignItems: 'center', 
  },
  texto: {
    fontSize: 21,
    fontWeight: '900',
    color: '#FFF' 
  },
  sortear: {
    margin: 4,
  },
  texto2: {
    fontSize: 32,
    fontWeight: '900',
    color: '#FFF' 
  },
});
